import { DVCProvider as DVCProvider$1, withDVCProvider as withDVCProvider$1 } from '@devcycle/devcycle-react-sdk';
export { useDVCClient, useIsDVCInitialized, useVariable, useVariableValue } from '@devcycle/devcycle-react-sdk';
import 'react';
import AsyncStorage from '@react-native-async-storage/async-storage';
import { jsx } from 'react/jsx-runtime';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var ReactNativeStore =
/** @class */
function () {
  function ReactNativeStore() {
    this.store = AsyncStorage;
  }

  ReactNativeStore.prototype.save = function (storeKey, data) {
    this.store.setItem(storeKey, JSON.stringify(data));
  };

  ReactNativeStore.prototype.load = function (storeKey) {
    return this.store.getItem(storeKey).then(function (item) {
      return item ? JSON.parse(item) : undefined;
    });
  };

  ReactNativeStore.prototype.remove = function (storeKey) {
    this.store.removeItem(storeKey);
  };

  return ReactNativeStore;
}();

var DVCProvider = function DVCProvider(props) {
  var config = getReactNativeConfig(props.config);
  return /*#__PURE__*/jsx(DVCProvider$1, {
    config: config,
    children: props.children
  });
};
var getReactNativeConfig = function getReactNativeConfig(config) {
  var _a;

  var rnConfig = __assign(__assign({}, config), {
    options: __assign(__assign({}, config.options), {
      reactNative: true
    })
  });

  if (!((_a = config.options) === null || _a === void 0 ? void 0 : _a.storage)) {
    rnConfig.options.storage = new ReactNativeStore();
  }

  return rnConfig;
};

var withDVCProvider = function withDVCProvider(config) {
  var reactNativeConfig = getReactNativeConfig(config);
  return withDVCProvider$1(reactNativeConfig);
};

export { DVCProvider, withDVCProvider };
